import java.awt.Color;
import java.util.List;
import java.util.Arrays;

public class Eye implements Comparable<Eye> {
    private Color color;
    private List<String> colorList = Arrays.asList("black", "green", "blue", "brown");

    /**
     *
     * @param color
     */
    Eye(String color) {
        setColor(color);
    }

    /**
     *
     * @return
     */
    public Color getColor() {
        return color;
    }

    /**
     *
     * @param color
     */
    public void setColor(String color) {
        if (validateColor(color)) {
            if (color.equals("brown"))
                this.color = new Color(88, 41, 0);
            else
                this.color = Color.getColor(color);

        } else {
            throw new IllegalArgumentException("Color must be " + colorList.toString());
        }
    }

    /**
     *
     * @param color
     * @return
     */
    private boolean validateColor(String color) {
        return colorList.contains(color);
    }

    /**
     *
     * @param eye
     * @return
     */
    @Override
    public int compareTo(Eye eye) {
        double r_diff = this.getColor().getRed() - eye.getColor().getRed();
        double g_diff = this.getColor().getGreen() - eye.getColor().getGreen();
        double b_diff = this.getColor().getBlue() - eye.getColor().getBlue();
        // See https://en.wikipedia.org/wiki/Color_difference
        Double distance = Math.sqrt(2 * Math.pow(r_diff, 2) + 4 * Math.pow(g_diff, 2) + 3 * Math.pow(b_diff, 2));
        return distance.intValue();
    }
}
