public class Size implements Comparable<Size> {
    private int max = 240;
    private int min = 20;
    private int size;

    Size(int size) {
        setSize(size);
    }

    public int getSize() {
        return size;
    }

    public void setSize(int size) {
        if (validateSize(size)) {
            this.size = size;
        } else {
            throw new IllegalArgumentException("Size must be between" + this.min + " and " + this.max);
        }
    }

    private boolean validateSize(int size) {
        return (size > max || size < min);
    }

    @Override
    public int compareTo(Size size) {
        int distance = size.size - this.getSize();
        if (distance >= 0)
            return distance;
        else
            return -distance;

    }
}
